#!/usr/bin/env python2
# coding: utf-8
from __future__ import print_function, unicode_literals

import re
import sys
import time
import hashlib


t00 = time.time()
ptn = re.compile("^md5|sha[0-9]")
txt = b"hash me bro" * 8
its = int(sys.argv[1])

smp = []
for _ in range(10):
    for k in [x for x in dir(hashlib) if ptn.match(x)]:
        fun = getattr(hashlib, k)
        try:
            fun(txt).digest()
        except:
            pass

        t0 = time.time()
        for _ in range(its):
            fun(txt).digest()

        smp.append([time.time() - t0, k])

        # 8x slower:
        # t = timeit.Timer("hashlib.%s(data).digest()" % k, "import hashlib; data=%s" % txt).timeit(100)

res = {}
ret = []
for t, k in sorted(smp):
    if k not in res:
        res[k] = t
        ret.append(k)
        print("{:.6f} {}".format(t, k))

t = time.time()
print(t - t00)
